<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Block Symbol Tables</TITLE>
<link href="suif1_46.html" rel=Next>
<link href="suif1_44.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_44.html">previous</A>, <A HREF="suif1_46.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC45" HREF="suif1_toc.html#TOC45">Block Symbol Tables</A></H3>
<P>
<A NAME="IDX278"></A>
<A NAME="IDX279"></A>

</P>
<P>
<A NAME="IDX280"></A>
<A NAME="IDX281"></A>
The <CODE>block_symtab</CODE> class is used for nested block symbol tables and
as the base class for procedure symbol tables.  Each one is associated
with a particular <CODE>tree_block</CODE> (or <CODE>tree_proc</CODE>) node in an
abstract syntax tree.  See section <A HREF="suif1_18.html#SEC18">Block Nodes</A>.  Each block symbol table
contains a pointer to the corresponding <CODE>tree_block</CODE> node.  The
<CODE>block</CODE> method retrieves the value of this pointer.  When a symbol
table is connected to a <CODE>tree_block</CODE>, its <CODE>block</CODE> pointer is
set automatically.

</P>
<P>
Since label symbols may not be declared in global scopes, the
<CODE>block_symtab</CODE> class is the natural place to provide methods for
working with labels.  The <CODE>new_label</CODE> method creates a new label
symbol and enters it in the table (see section <A HREF="suif1_48.html#SEC48">Creating New Entries</A>).  The
<CODE>new_unique_label</CODE> does the same thing but it first makes sure that
the label will have a unique name.  The <CODE>lookup_label</CODE> method
searches for an existing label symbol (see section <A HREF="suif1_47.html#SEC47">Lookup Methods</A>).

</P>
<P>
Block symbol tables also provide a method to create a new child symbol
table, i.e. an inner scope.  The <CODE>new_unique_child</CODE> method can be
used to create a new child block symtab with a unique name
(see section <A HREF="suif1_48.html#SEC48">Creating New Entries</A>).  This method is not provided for global
symbol tables, because their children must correspond to procedures,
which already have unique names.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_44.html">previous</A>, <A HREF="suif1_46.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
